searchNodes=[{"doc":"Provide easy access to information inside the templates rendered by mix xtra","ref":"Extractly.html","title":"Extractly","type":"module"},{"doc":"Emits a comment including a message not to edit the created file, as it will be recreated from this template. It is a convenience to include this into your templates as follows &lt; % = xtra . do_not_edit_warning % &gt; or I18n'ed &lt; % = xtra . do_not_edit_warning , lang : :fr % &gt; If you are not generating html or markdown the comment can be parametrized &lt; % = xtra . do_not_edit_warning , comment_start : &quot;-- &quot; , comment_end : &quot;&quot; % &gt; If you want to include the name of the source template use template: template option, so a call may be as complex as: &lt; % = xtra . do_not_edit_warning , comment_start : &quot;-- &quot; , comment_end : &quot;&quot; , template : template , lang : :it % &gt;","ref":"Extractly.html#do_not_edit_warning/1","title":"Extractly.do_not_edit_warning/1","type":"function"},{"doc":"Returns docstring of a function Ex: iex(0)&gt; { :ok , lines } = Extractly . functiondoc ( &quot;Extractly.moduledoc/2&quot; ) |&gt; hd ( ) ...(0)&gt; lines |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 3 ) [ &quot; Returns docstring of a module&quot; , &quot; Ex:&quot; , &quot;&quot; ] We can also pass a list of functions to get their docs concatenated iex(1)&gt; [ { :ok , moduledoc } , { :error , message } ] = Extractly . functiondoc ( [ &quot;Extractly.moduledoc/2&quot; , &quot;Extactly.functiondoc/2&quot; ] ) ...(1)&gt; moduledoc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 4 ) [ &quot; Returns docstring of a module&quot; , &quot; Ex:&quot; , &quot;&quot; , &quot; Extractly.moduledoc( \\&quot; Extractly \\&quot; )&quot; ] iex(2)&gt; message &quot;Function doc for function Extactly.functiondoc/2 not found&quot; If all the functions are in the same module the following form can be used iex(3)&gt; [ { :ok , out } , _ ] = Extractly . functiondoc ( [ &quot;moduledoc/2&quot; , &quot;functiondoc/2&quot; ] , module : &quot;Extractly&quot; ) ...(3)&gt; String . split ( out , &quot; \\n &quot; ) |&gt; hd ( ) &quot; Returns docstring of a module&quot; However it is convenient to add a markdown headline before each functiondoc, especially in these cases, it can be done by indicating the headline: level option iex(4)&gt; [ { :ok , moduledoc } , { :ok , functiondoc } ] = Extractly . functiondoc ( [ &quot;moduledoc/2&quot; , &quot;functiondoc/2&quot; ] , module : &quot;Extractly&quot; , headline : 2 ) ...(4)&gt; moduledoc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 3 ) [ &quot;## Extractly.moduledoc/2&quot; , &quot;&quot; , &quot; Returns docstring of a module&quot; ] iex(5)&gt; functiondoc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 3 ) [ &quot;## Extractly.functiondoc/2&quot; , &quot;&quot; , &quot; Returns docstring of a function&quot; ] Often times we are interested by all public functiondocs... iex(6)&gt; [ { :ok , out } | _ ] = Extractly . functiondoc ( :all , module : &quot;Extractly&quot; , headline : 2 ) ...(6)&gt; String . split ( out , &quot; \\n &quot; ) |&gt; Enum . take ( 3 ) [ &quot;## Extractly.do_not_edit_warning/1&quot; , &quot;&quot; , &quot; Emits a comment including a message not to edit the created file, as it will be recreated from this template.&quot; ] We can specify a language to wrap indented code blocks into ```elixir\\n...\\n``` Here is an example iex(7)&gt; [ ok : doc ] = Extractly . functiondoc ( &quot;Extractly.functiondoc/2&quot; , wrap_code_blocks : &quot;elixir&quot; ) ...(7)&gt; doc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 10 ) [ &quot; Returns docstring of a function&quot; , &quot; Ex:&quot; , &quot;&quot; , &quot;```elixir&quot; , &quot; iex(0)&gt; {:ok, lines} = Extractly.functiondoc( \\&quot; Extractly.moduledoc/2 \\&quot; ) |&gt; hd()&quot; , &quot; ...(0)&gt; lines |&gt; String.split( \\&quot; \\\\ n \\&quot; ) |&gt; Enum.take(3)&quot; , &quot; [ \\&quot; Returns docstring of a module \\&quot; , \\&quot; Ex: \\&quot; , \\&quot; \\&quot; ]&quot; , &quot;```&quot; , &quot;&quot; , &quot; We can also pass a list of functions to get their docs concatenated&quot; ]","ref":"Extractly.html#functiondoc/2","title":"Extractly.functiondoc/2","type":"function"},{"doc":"Returns docstring of a macro Same naming convention for macros as for functions.","ref":"Extractly.html#macrodoc/2","title":"Extractly.macrodoc/2","type":"function"},{"doc":"Returns docstring of a module Ex: Extractly . moduledoc ( &quot;Extractly&quot; )","ref":"Extractly.html#moduledoc/2","title":"Extractly.moduledoc/2","type":"function"},{"doc":"Returns the output of a mix task Ex: iex(8)&gt; Extractly . task ( &quot;cmd&quot; , ~W[echo 42] ) &quot;42 \\n &quot; iex(9)&gt; try do ...(9)&gt; Extractly . task ( &quot;xxx&quot; ) ...(9)&gt; rescue ...(9)&gt; e in RuntimeError -&gt; e . message |&gt; String . split ( &quot; \\n &quot; ) |&gt; hd ( ) ...(9)&gt; end &quot;The following output was produced wih error code 1&quot;","ref":"Extractly.html#task/2","title":"Extractly.task/2","type":"function"},{"doc":"A convenience method to access this libraries version","ref":"Extractly.html#version/0","title":"Extractly.version/0","type":"function"},{"doc":"Exposes the mix task as an escript for usage on non mix projects","ref":"Extractly.Cli.html","title":"Extractly.Cli","type":"module"},{"doc":"entry to the CLI, proxies to the mix task mix xtra","ref":"Extractly.Cli.html#main/1","title":"Extractly.Cli.main/1","type":"function"},{"doc":"Processes the extracted docstring according to %extractly%&lt;directive&gt;% directives","ref":"Extractly.Directives.html","title":"Extractly.Directives","type":"module"},{"doc":"","ref":"Extractly.Directives.html#process/2","title":"Extractly.Directives.process/2","type":"function"},{"doc":"Implements the storage of DO NOT EDIT warning messages for languages and various variations.","ref":"Extractly.DoNotEdit.html","title":"Extractly.DoNotEdit","type":"module"},{"doc":"Resolves to the correctly configured and internationalized message","ref":"Extractly.DoNotEdit.html#warning/1","title":"Extractly.DoNotEdit.warning/1","type":"function"},{"doc":"","ref":"Extractly.Frontend.html","title":"Extractly.Frontend","type":"module"},{"doc":"Implementation of the BL around the message collecting agent Extractly.Messages.Agent","ref":"Extractly.Messages.html","title":"Extractly.Messages","type":"module"},{"doc":"","ref":"Extractly.Messages.html#add_debug/1","title":"Extractly.Messages.add_debug/1","type":"function"},{"doc":"","ref":"Extractly.Messages.html#add_error/1","title":"Extractly.Messages.add_error/1","type":"function"},{"doc":"","ref":"Extractly.Messages.html#add_info/1","title":"Extractly.Messages.add_info/1","type":"function"},{"doc":"","ref":"Extractly.Messages.html#add_warning/1","title":"Extractly.Messages.add_warning/1","type":"function"},{"doc":"","ref":"Extractly.Messages.html#messages/1","title":"Extractly.Messages.messages/1","type":"function"},{"doc":"An agent that collects messages from all templates","ref":"Extractly.Messages.Agent.html","title":"Extractly.Messages.Agent","type":"module"},{"doc":"","ref":"Extractly.Messages.Agent.html#add_message/1","title":"Extractly.Messages.Agent.add_message/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Extractly.Messages.Agent.html#child_spec/1","title":"Extractly.Messages.Agent.child_spec/1","type":"function"},{"doc":"","ref":"Extractly.Messages.Agent.html#messages/0","title":"Extractly.Messages.Agent.messages/0","type":"function"},{"doc":"","ref":"Extractly.Messages.Agent.html#start_link/0","title":"Extractly.Messages.Agent.start_link/0","type":"function"},{"doc":"This wraps Extractly's API by putting all messages to be logged to the Extractly.Messages module. Its primarty use case is for Mix.Tasks.Xtra which will pass this module as a param into the EEx template. The general idea is Extractly.Messages . start_agent process_input_template # which will collect messages by means of this module&#39;s API Extractly.Messages . get_all |&gt; emit_messages ( options ) The wrapping works as follows def some_function ( some_params ) do case Extractly . some_function ( some_params ) do { :ok , result } -&gt; result { :error , message } -&gt; add_message_to_messages_and_return_html_comment_describing_the_error ( ) end end","ref":"Extractly.Xtra.html","title":"Extractly.Xtra","type":"module"},{"doc":"Just a delegator to Extractly.do_not_edit_warning As there can be no error condition no wrapping is needed iex(0)&gt; do_not_edit_warning() &quot;&lt;!--\\nDO NOT EDIT THIS FILE\\nIt has been generated from a template by Extractly ( https://github.com/RobertDober/extractly.git)\\nand any changes you make in this file will most likely be lost\\n--&gt;&quot;","ref":"Extractly.Xtra.html#do_not_edit_warning/1","title":"Extractly.Xtra.do_not_edit_warning/1","type":"function"},{"doc":"Wraps call to Extractly.functiondoc as described above iex(1)&gt; functiondoc ( [ &quot;Support.Module2.function/0&quot; , &quot;Support.Module1.hello/0&quot; ] ) &quot;A function \\n A nice one \\n \\n Functiondoc of Module1.hello \\n &quot;","ref":"Extractly.Xtra.html#functiondoc/2","title":"Extractly.Xtra.functiondoc/2","type":"function"},{"doc":"Wraps call to Extractly.moduledoc as described above iex(2)&gt; moduledoc ( &quot;Support.Module2&quot; ) &quot;&lt;!-- module Support.Module2 does not have a moduledoc --&gt;&quot;","ref":"Extractly.Xtra.html#moduledoc/2","title":"Extractly.Xtra.moduledoc/2","type":"function"},{"doc":"Mix task to Transform EEx templates in the context of the Extractly module. This tool serves two purposes. A simple CLI to basicly EEx.eval_file/2 Access to the Extractly module (available as binding xtra too) Access to the name of the rendered template with the template binding The Extractly module gives easy access to Elixir metainformation of the application using the extractly package, notably, module and function documentation. This is BTW the raison d'être of this package, simple creation of a README.md file with very simple access to the projects hex documentation. Thusly hexdoc and Github will always be synchronized. To see that in action just look at the README.md.eex file of this package and compare with what you are reading here. Example Template: Some text &lt; % = xtra . functiondoc ( &quot;M.shiny_function/2&quot; ) % &gt; &lt; % = xtra . moduledoc ( &quot;String&quot; ) % &gt; More text","ref":"Mix.Tasks.Xtra.html","title":"Mix.Tasks.Xtra","type":"task"},{"doc":"Usage: mix xtra [ options ] ... [ template ] Options: -- help | - h Prints short help information to stdout and exits . -- quiet | - q No output to stdout or stderr -- version | - v Prints the current version to stdout and exits . -- verbose | - V Prints additional output to stderr -- output filename The name of the file the rendered template is written to , defaults to the templates &#39; name , without the suffix ` . eex ` Argument: template , filename of the ` EEx ` template to use , defaults to ` &quot;README.md.eex&quot; `","ref":"Mix.Tasks.Xtra.Help.html","title":"Mix.Tasks.Xtra.Help","type":"task"}]